#!/bin/vtcl
# ---------------------------------------------------------------------
# Copyright 1994 by SCO, Inc.
# Permission to use, copy, modify, distribute, and sell this software
# and its documentation for any purpose is hereby granted without fee,
# provided that the above copyright notice appear in all copies and that
# both that copyright  notice  and  this  permission  notice  appear  in
# supporting documentation, and that the name  of  SCO  not  be used  in
# advertising or publicity pertaining  to distribution of  the  software
# without   specific,   written  prior   permission.    SCO   makes   no
# representations  about  the  suitability  of  this  software  for  any
# purpose.  It is provided "as is" without express or implied warranty.
# ---------------------------------------------------------------------

# Demo		: info.tcl
# Description	: Simple message dialog, displaying general environmental
#		  information.

proc QuitCB {cbs} {
    VtClose; exit 0
}

# Must establish connection with the display engine before
# querying about the graphical environment.
set app [VtOpen info]

set charm [VtInfo -charm]
set version [VtInfo -version]
set colors [VtInfo -colors]
set height [VtInfo -displayHeight]
set width [VtInfo -displayWidth]

set msg "Charm is $charm\nVersion is $version\nNumber of Colors: $colors
Dimension: $width X $height"

set dlog [VtMessageDialog $app.mess \
	-message $msg \
	-ok \
	-okCallback QuitCB \
	-font medItalicFont \
	]

VtShow $dlog
VtMainLoop
